//#include<_defs.h>
//#include <dos.h>
#include <stdlib.h>
//#include<fcntl.h>
/* The clock tick interrupt */
#define TIMER_INTR 0x1C
/* The keyboard interrupt */
#define KEYBOARD_INTR 0x09

#define rightshift 1
#define leftshift 2
#define ctrl 4
#define alt 8

#ifdef __cplusplus
    #define __CPPARGS ...
#else
    #define __CPPARGS
#endif

typedef void (far *FCP)(__CPPARGS);
extern unsigned int _psp;
volatile int count;
volatile int MAX_COUNT;
volatile int saving_screen;
int ROWS,COLS;
char MODE,CURSOR_ROW,CURSOR_COL,SPRITE_ROW,SPRITE_COL;
char PAGE,PAGE2;
char ticks;
char flag;
/* reduce heaplength and stacklength to make a smaller program in memory */
extern unsigned _heaplen = 1024;
extern unsigned _stklen  = 512;

FCP oldtimerhandler;
FCP oldkeyboardhandler;
/*/From The MS-DOS Encyclopedia 1988 Microsoft Press
converted from oldstyle to newstyle by Billy Stiltner MountainSoft.

!NOTE! use setvect from dos.h for the c++ interrupt function type.
"set_vector" takes a void (far*)(...)
Instead of a void interrupt (*)(...)  which setvector takes.

The interrupt modifier makes a function preserve registers
AX, BX, CX, DX, SI, DI, _ES, and DS.  An IRET will be placed at the
end of an interrupt function. In all memory models except huge
DS is set to the programs data segment. For the huge model DS is
set to the modules data segment. Preserving all registers  is good
for Hardware Interrupts that occur at any time.

A normal c++ function and an interrupt modified function auomatically
preserves BP, SP, SS, CS, and IP. This is good for returning values
and entering with values from/to by an interrupt. Mozart wrote music
that could be played forward and backwards.
/*/

////////////////////////////////////////////////////////////////////////////
//if(__cplusplus) (__CPPARGS || ...) = variable length argument list
//else(plain ol C)__CPPARGS || "REQUIRED SPACE, NONREQUIRED SPACE,or NO SPACE"
//=variable length argument list
#ifdef __cplusplus
	 #define __CPPARGS ...
#else
	 #define __CPPARGS
#endif
///////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////
int set_vector(char intnum,FCP vector);
FCP get_vector(char intnum);
/////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////
int set_vector(char intnum,FCP vector)
{
asm{
lds dx,vector;//Get vector segment:offset into DS:DX
mov al,intnum;//Get interrupt number into al
mov ah,25h;   //Select "set vector" function
int 21h;      //Ask MS DOS to change vector
xor ax,ax;    //Return 0
};
};
/////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////
FCP get_vector(char intnum)
{
asm{
mov al,intnum;//Get interrupt number in al
mov ah,35h;   //Select "get vector" function
int 21h;      //Call MS DOS
mov ax,bx;    //Return vector offset
mov dx,es;    //Return vector segment
};
};
/////////////////////////////////////////////////////////////////////////

void save_screen(void);
void restore_screen(void);
void puttext(char row,char col,char page,char character,char num);

void puttext(char row,char col,char page,char charac,char attr,char num)
{
   asm{
		       mov ah,2;//set cursor position
		       mov DH,col;//column
		       mov DL,row;//row
		       mov bh,page;//page
		       int 10h
		       mov ah,9 //subfunction to write character and attribute
		       mov bh,page //page 0
		       mov al,charac //character
		       mov bl,attr; //attribute
		       mov cl,num;//#repeat
		       mov ch,0;
		       int 10h  //video interrupt

		    };
};

void far timerhandler(__CPPARGS)
{
    //call the old handler
    oldtimerhandler();
  /* increase the counter  */
   count++;
   if((count==MAX_COUNT)&&(saving_screen==0))
      {
       save_screen();
       count=0;
      }else{
	     if(saving_screen==1)
	       {
		 if(count==5)
		   {
		    count=0;
		    puttext(SPRITE_ROW,
			    SPRITE_COL,
			    PAGE2,
			    219,
			    0,
			    1);
		    SPRITE_ROW++;
		    SPRITE_COL++;
		    if(SPRITE_ROW>=ROWS)SPRITE_ROW=0;
		    if(SPRITE_COL>=COLS)SPRITE_COL=0;
		    puttext(SPRITE_ROW,
			    SPRITE_COL,
			    PAGE2,
			    219,
			    4,
			    1);
		  };
		};
	   };


}

void far keyboardhandler(__CPPARGS)
{
oldkeyboardhandler();
if(saving_screen==1)
  {
   restore_screen();
  };
count=0;
}

void save_screen(void)
{
int index;
char x,y;
char character,attribute;
index=0;
asm {
     mov ah,15;//sub function get video mode
     int 10h;//video interrupt
     mov MODE,al;
     mov PAGE,BH;
     };

//set ROWS and COLS according to video mode
if((MODE==0)||(MODE==1)||(MODE==4)||(MODE==5)||(MODE==9)||(MODE==13)||(MODE==19))
  {
   ROWS=40;COLS=25;
  };
if((MODE==2)||(MODE==3)||(MODE==6)||(MODE==10)||(MODE==14)||(MODE==15)||(MODE==16))
{
 ROWS=80;COLS=25;
};
if((MODE==17)||(MODE==18))
{
ROWS=80;COLS=30;
};
if(MODE==8)
{
ROWS=20;COLS=25;
};
////////////////////////////////////////////////////////////////////////


//get cursor ROW, COLUMN, and ATTRIBUTE
asm{
    mov ah,3;//subfunction to get CURSOR POSITION
    int 10h;
    mov CURSOR_ROW,DH;
    mov CURSOR_COL,DL;
   };


      PAGE2=PAGE+1;
      asm{
      mov ah,5h
      mov al,PAGE2;
      int 10h;
      };

///////////////////////////////////////////////////////

//blank the screen//////////////////////////////////
//index=0;
for(x=0;x<COLS;x++)
    {
     for(y=0;y<ROWS;y++)
	{
	    //character=videochar[index];
	    //attribute=videoattr[index];
		   puttext(y,
			   x,
			   PAGE2,
			   255,
			   0,
			   1);

	};
    };
////////////////////////////////////////////////////
saving_screen=1;
};

void restore_screen(void)
{
int index;
char x,y;
char character,attribute;
//restore the screen//////////////////////////////////
saving_screen=0;
//index=0;


 asm{
     mov ah,5h;
     mov al,PAGE;
     int 10h;
     };

    asm{
	      mov ah,2;//set cursor position
	      mov DH,CURSOR_ROW;
	      mov DL,CURSOR_COL;
	      mov bh,PAGE;
	      int 10h
	      };
////////////////////// //////////////////////////////

}

int main(int argc,char *argv[])
{
int OLDTSEG,OLDTOFF,OLDKSEG,OLDKOFF;
asm{
mov ah,6;mov dl,'P';int 21h;
mov ah,6;mov dl,'A';int 21h;
mov ah,6;mov dl,'G';int 21h;
mov ah,6;mov dl,'E';int 21h;
mov ah,6;mov dl,'X';int 21h;
mov ah,6;mov dl,' ';int 21h;
mov ah,6;mov dl,'1';int 21h;
mov ah,6;mov dl,'.';int 21h;
mov ah,6;mov dl,'0';int 21h;
mov ah,6;mov dl,' ';int 21h;
mov ah,6;mov dl,'(';int 21h;
mov ah,6;mov dl,'c';int 21h;
mov ah,6;mov dl,')';int 21h;
mov ah,6;mov dl,' ';int 21h;
mov ah,6;mov dl,'1';int 21h;
mov ah,6;mov dl,'9';int 21h;
mov ah,6;mov dl,'9';int 21h;
mov ah,6;mov dl,'5';int 21h;
mov ah,6;mov dl,' ';int 21h;
mov ah,6;mov dl,'M';int 21h;
mov ah,6;mov dl,'O';int 21h;
mov ah,6;mov dl,'U';int 21h;
mov ah,6;mov dl,'N';int 21h;
mov ah,6;mov dl,'T';int 21h;
mov ah,6;mov dl,'A';int 21h;
mov ah,6;mov dl,'I';int 21h;
mov ah,6;mov dl,'N';int 21h;
mov ah,6;mov dl,' ';int 21h;
mov ah,6;mov dl,'S';int 21h;
mov ah,6;mov dl,'O';int 21h;
mov ah,6;mov dl,'F';int 21h;
mov ah,6;mov dl,'T';int 21h;
mov ah,6;mov dl,13;int 21h;

};


count=0;
MAX_COUNT=546;
saving_screen=0;
SPRITE_ROW=1;
SPRITE_COL=1;

if(argc>1)MAX_COUNT=(atoi(argv[1])*18);
/* get the address of the current clock
   tick interrupt */
oldtimerhandler = get_vector(TIMER_INTR);
   /* install the new interrupt handler */
set_vector(TIMER_INTR, timerhandler);

//get the address of the current keyboard interrupt
oldkeyboardhandler = get_vector(KEYBOARD_INTR);

//install the new interrupt handler
set_vector(KEYBOARD_INTR, keyboardhandler);
asm{
//keep(0, 522);
mov ah,31h;
mov al,0;
mov dx,522;
int 21h
};
return 0;
}
